package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.BleManager _manager = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static anywheresoftware.b4a.objects.BleManager.GattServiceWrapper _s = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _c = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cwrite = null;
public static byte _x = (byte)0;
public static int _connect = 0;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _bt = null;
public static int _cstateidle = 0;
public static int _cstateconnect = 0;
public static int _cstateondisconnect = 0;
public static int _cstateonclose = 0;
public static int _cstateonfinish = 0;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="x = 0";
_x = (byte) (0);
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="BT.Initialize(\"BT\")";
_bt.Initialize(processBA,"BT");
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="Timer1.Initialize(\"Timer\",500)";
_timer1.Initialize(processBA,"Timer",(long) (500));
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="Timer1.Enabled=True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="Connect = cstateIdle";
_connect = _cstateidle;
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="manager.Initialize(\"ble\")";
_manager.Initialize(processBA,"ble");
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="Button1.Enabled = False";
mostCurrent._button1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="Button2.Enabled = True";
mostCurrent._button2.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="Button3.Enabled = False";
mostCurrent._button3.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="Connect = cstateIdle";
_connect = _cstateidle;
 };
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume()";
RDebugUtils.currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="x = 0";
_x = (byte) (0);
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicchanged(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub ble_CharacteristicChanged (Characteristic As BleCharacteristic)";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="Log(\"ble_CharacteristicChanged\")";
anywheresoftware.b4a.keywords.Common.Log("ble_CharacteristicChanged");
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="Log(\"Change: \" & Characteristic.GetIntValue(Characteristic.FORMAT_UINT8,0))	'Get one byte";
anywheresoftware.b4a.keywords.Common.Log("Change: "+BA.NumberToString(_characteristic.GetIntValue(_characteristic.FORMAT_UINT8,(int) (0))));
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicread(boolean _success,anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub ble_CharacteristicRead (Success As Boolean, Characteristic As BleCharacteristic)";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="Log(\"ble_CharacteristicRead\")";
anywheresoftware.b4a.keywords.Common.Log("ble_CharacteristicRead");
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="If Success Then";
if (_success) { 
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="Log(\"Data: \" & Characteristic.GetIntValue(Characteristic.FORMAT_UINT8,0))";
anywheresoftware.b4a.keywords.Common.Log("Data: "+BA.NumberToString(_characteristic.GetIntValue(_characteristic.FORMAT_UINT8,(int) (0))));
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="Button3.Enabled = True";
mostCurrent._button3.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
RDebugUtils.currentLine=458758;
 //BA.debugLineNum = 458758;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicwrite(boolean _success,anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub ble_CharacteristicWrite (Success As Boolean, Characteristic As BleCharacteristic)";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="Log(\"ble_CharacteristicWrite\")";
anywheresoftware.b4a.keywords.Common.Log("ble_CharacteristicWrite");
RDebugUtils.currentLine=589830;
 //BA.debugLineNum = 589830;BA.debugLine="Log(\"Write Success \"& Success & \" Val After write: \" & Characteristic.GetIntValue(Characteristic.FORMAT_UINT8,0))";
anywheresoftware.b4a.keywords.Common.Log("Write Success "+BA.ObjectToString(_success)+" Val After write: "+BA.NumberToString(_characteristic.GetIntValue(_characteristic.FORMAT_UINT8,(int) (0))));
RDebugUtils.currentLine=589832;
 //BA.debugLineNum = 589832;BA.debugLine="End Sub";
return "";
}
public static String  _ble_connected(anywheresoftware.b4a.objects.collections.Map _services) throws Exception{
RDebugUtils.currentModule="main";
int _i = 0;
int _j = 0;
int _n = 0;
int _cw = 0;
int _cr = 0;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub ble_Connected (Services As Map)";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Dim i,j,n ,cw,cr As Int";
_i = 0;
_j = 0;
_n = 0;
_cw = 0;
_cr = 0;
RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="If Connect==cstateIdle Then";
if (_connect==_cstateidle) { 
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="Log(\"Connected\")";
anywheresoftware.b4a.keywords.Common.Log("Connected");
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="Button1.Enabled = True";
mostCurrent._button1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=393226;
 //BA.debugLineNum = 393226;BA.debugLine="Button2.Enabled = False";
mostCurrent._button2.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=393231;
 //BA.debugLineNum = 393231;BA.debugLine="For i = 0 To  Services.Size - 1";
{
final int step53 = 1;
final int limit53 = (int) (_services.getSize()-1);
for (_i = (int) (0); (step53 > 0 && _i <= limit53) || (step53 < 0 && _i >= limit53); _i = ((int)(0 + _i + step53))) {
RDebugUtils.currentLine=393232;
 //BA.debugLineNum = 393232;BA.debugLine="s = Services.GetValueAt(i)";
_s.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt(_i)));
RDebugUtils.currentLine=393233;
 //BA.debugLineNum = 393233;BA.debugLine="Log(\"Service[\" & i & \"]: \" & Services.GetKeyAt(i))	' Log the UUID of the selected Service";
anywheresoftware.b4a.keywords.Common.Log("Service["+BA.NumberToString(_i)+"]: "+BA.ObjectToString(_services.GetKeyAt(_i)));
RDebugUtils.currentLine=393234;
 //BA.debugLineNum = 393234;BA.debugLine="For j = 0 To  s.GetCharacteristics.Size - 1";
{
final int step56 = 1;
final int limit56 = (int) (_s.GetCharacteristics().getSize()-1);
for (_j = (int) (0); (step56 > 0 && _j <= limit56) || (step56 < 0 && _j >= limit56); _j = ((int)(0 + _j + step56))) {
RDebugUtils.currentLine=393235;
 //BA.debugLineNum = 393235;BA.debugLine="c  = s.GetCharacteristics.GetValueAt(j)";
_c.setObject((android.bluetooth.BluetoothGattCharacteristic)(_s.GetCharacteristics().GetValueAt(_j)));
RDebugUtils.currentLine=393236;
 //BA.debugLineNum = 393236;BA.debugLine="Log(\"      C[\" & j &\"] : Uuid \" & c.Uuid)";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"] : Uuid "+_c.getUuid());
RDebugUtils.currentLine=393237;
 //BA.debugLineNum = 393237;BA.debugLine="Log(\"      C[\" & j &\"]: Permissions\" & BleCharacteristicPermissionsToString(c))";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: Permissions"+_blecharacteristicpermissionstostring(_c));
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="Log(\"      C[\" & j &\"]: Properties \" & BleCharacteristicPropertiesToString(c))";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: Properties "+_blecharacteristicpropertiestostring(_c));
RDebugUtils.currentLine=393239;
 //BA.debugLineNum = 393239;BA.debugLine="Log(\"      C[\" & j &\"]: WriteType  \" & BleCharacteristicWriteTypeToString(c))";
anywheresoftware.b4a.keywords.Common.Log("      C["+BA.NumberToString(_j)+"]: WriteType  "+_blecharacteristicwritetypetostring(_c));
 }
};
 }
};
RDebugUtils.currentLine=393243;
 //BA.debugLineNum = 393243;BA.debugLine="n = 2						                     ' the third service is the user read write service of the RfDuino";
_n = (int) (2);
RDebugUtils.currentLine=393244;
 //BA.debugLineNum = 393244;BA.debugLine="Log (\"AanzahlServices\" & Services.Size)";
anywheresoftware.b4a.keywords.Common.Log("AanzahlServices"+BA.NumberToString(_services.getSize()));
RDebugUtils.currentLine=393245;
 //BA.debugLineNum = 393245;BA.debugLine="s = Services.GetValueAt(n)";
_s.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt(_n)));
RDebugUtils.currentLine=393246;
 //BA.debugLineNum = 393246;BA.debugLine="Log(\"Service[\" & n & \"]: \" & Services.GetKeyAt(n))	' Log the UUID of the selected Service";
anywheresoftware.b4a.keywords.Common.Log("Service["+BA.NumberToString(_n)+"]: "+BA.ObjectToString(_services.GetKeyAt(_n)));
RDebugUtils.currentLine=393249;
 //BA.debugLineNum = 393249;BA.debugLine="cr = 0                                   ' the first characteristic is the read characteristic";
_cr = (int) (0);
RDebugUtils.currentLine=393251;
 //BA.debugLineNum = 393251;BA.debugLine="c = s.GetCharacteristics.GetValueAt(cr)";
_c.setObject((android.bluetooth.BluetoothGattCharacteristic)(_s.GetCharacteristics().GetValueAt(_cr)));
RDebugUtils.currentLine=393252;
 //BA.debugLineNum = 393252;BA.debugLine="Log(\"read: \" & c.Uuid)";
anywheresoftware.b4a.keywords.Common.Log("read: "+_c.getUuid());
RDebugUtils.currentLine=393253;
 //BA.debugLineNum = 393253;BA.debugLine="manager.ReadCharacteristic(c)";
_manager.ReadCharacteristic(_c);
RDebugUtils.currentLine=393254;
 //BA.debugLineNum = 393254;BA.debugLine="manager.SetCharacteristicNotification(c, True)	'Define a Notification to get data RfDuino";
_manager.SetCharacteristicNotification(_c,anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=393256;
 //BA.debugLineNum = 393256;BA.debugLine="cw = 1";
_cw = (int) (1);
RDebugUtils.currentLine=393257;
 //BA.debugLineNum = 393257;BA.debugLine="cwrite = s.GetCharacteristics.GetValueAt(cw)  ' the second characteristic is the write characteristic";
_cwrite.setObject((android.bluetooth.BluetoothGattCharacteristic)(_s.GetCharacteristics().GetValueAt(_cw)));
RDebugUtils.currentLine=393258;
 //BA.debugLineNum = 393258;BA.debugLine="Log(\"Cwrite: \" & cwrite.Uuid)";
anywheresoftware.b4a.keywords.Common.Log("Cwrite: "+_cwrite.getUuid());
RDebugUtils.currentLine=393260;
 //BA.debugLineNum = 393260;BA.debugLine="Connect = cstateConnect";
_connect = _cstateconnect;
 };
RDebugUtils.currentLine=393262;
 //BA.debugLineNum = 393262;BA.debugLine="End Sub";
return "";
}
public static String  _blecharacteristicpermissionstostring(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cha) throws Exception{
RDebugUtils.currentModule="main";
anywheresoftware.b4a.keywords.StringBuilderWrapper _output = null;
RDebugUtils.currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Sub BleCharacteristicPermissionsToString ( Cha As BleCharacteristic) As String";
RDebugUtils.currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="Dim Output As StringBuilder";
_output = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
RDebugUtils.currentLine=1114116;
 //BA.debugLineNum = 1114116;BA.debugLine="Output.Initialize";
_output.Initialize();
RDebugUtils.currentLine=1114118;
 //BA.debugLineNum = 1114118;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_READ) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_READ)!=0) { 
RDebugUtils.currentLine=1114119;
 //BA.debugLineNum = 1114119;BA.debugLine="Output.Append(\"Read \")";
_output.Append("Read ");
 };
RDebugUtils.currentLine=1114121;
 //BA.debugLineNum = 1114121;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_READ_ENCRYPTED) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_READ_ENCRYPTED)!=0) { 
RDebugUtils.currentLine=1114122;
 //BA.debugLineNum = 1114122;BA.debugLine="Output.Append(\"READ_ENCRYPTED \")";
_output.Append("READ_ENCRYPTED ");
 };
RDebugUtils.currentLine=1114124;
 //BA.debugLineNum = 1114124;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_READ_ENCRYPTED_MITM)  <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_READ_ENCRYPTED_MITM)!=0) { 
RDebugUtils.currentLine=1114125;
 //BA.debugLineNum = 1114125;BA.debugLine="Output.Append(\"Read_E_MITM \")";
_output.Append("Read_E_MITM ");
 };
RDebugUtils.currentLine=1114127;
 //BA.debugLineNum = 1114127;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE)!=0) { 
RDebugUtils.currentLine=1114128;
 //BA.debugLineNum = 1114128;BA.debugLine="Output.Append(\"Write \")";
_output.Append("Write ");
 };
RDebugUtils.currentLine=1114130;
 //BA.debugLineNum = 1114130;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE_ENCRYPTED)  <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE_ENCRYPTED)!=0) { 
RDebugUtils.currentLine=1114131;
 //BA.debugLineNum = 1114131;BA.debugLine="Output.Append(\"Write_ENCRYPTED \")";
_output.Append("Write_ENCRYPTED ");
 };
RDebugUtils.currentLine=1114133;
 //BA.debugLineNum = 1114133;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE)!=0) { 
RDebugUtils.currentLine=1114134;
 //BA.debugLineNum = 1114134;BA.debugLine="Output.Append(\"Write_E_MITM \")";
_output.Append("Write_E_MITM ");
 };
RDebugUtils.currentLine=1114136;
 //BA.debugLineNum = 1114136;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE_SIGNED) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE_SIGNED)!=0) { 
RDebugUtils.currentLine=1114137;
 //BA.debugLineNum = 1114137;BA.debugLine="Output.Append(\"Write_SIGNED \")";
_output.Append("Write_SIGNED ");
 };
RDebugUtils.currentLine=1114139;
 //BA.debugLineNum = 1114139;BA.debugLine="If Bit.AND(c.Permissions , Cha.PERMISSION_WRITE_SIGNED_MITM) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_c.getPermissions(),_cha.PERMISSION_WRITE_SIGNED_MITM)!=0) { 
RDebugUtils.currentLine=1114140;
 //BA.debugLineNum = 1114140;BA.debugLine="Output.Append(\"Write_S_MITM \")";
_output.Append("Write_S_MITM ");
 };
RDebugUtils.currentLine=1114143;
 //BA.debugLineNum = 1114143;BA.debugLine="Return Output.ToString";
if (true) return _output.ToString();
RDebugUtils.currentLine=1114145;
 //BA.debugLineNum = 1114145;BA.debugLine="End Sub";
return "";
}
public static String  _blecharacteristicpropertiestostring(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cha) throws Exception{
RDebugUtils.currentModule="main";
anywheresoftware.b4a.keywords.StringBuilderWrapper _output = null;
RDebugUtils.currentLine=1179648;
 //BA.debugLineNum = 1179648;BA.debugLine="Sub BleCharacteristicPropertiesToString ( cha As BleCharacteristic) As String";
RDebugUtils.currentLine=1179649;
 //BA.debugLineNum = 1179649;BA.debugLine="Dim Output As StringBuilder";
_output = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
RDebugUtils.currentLine=1179651;
 //BA.debugLineNum = 1179651;BA.debugLine="Output.Initialize";
_output.Initialize();
RDebugUtils.currentLine=1179652;
 //BA.debugLineNum = 1179652;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_BROADCAST) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_BROADCAST)!=0) { 
RDebugUtils.currentLine=1179653;
 //BA.debugLineNum = 1179653;BA.debugLine="Output.Append(\"BROADCAST \")";
_output.Append("BROADCAST ");
 };
RDebugUtils.currentLine=1179655;
 //BA.debugLineNum = 1179655;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_EXTENDED_PROPS) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_EXTENDED_PROPS)!=0) { 
RDebugUtils.currentLine=1179656;
 //BA.debugLineNum = 1179656;BA.debugLine="Output.Append(\"EXTENDED_PROPS \")";
_output.Append("EXTENDED_PROPS ");
 };
RDebugUtils.currentLine=1179658;
 //BA.debugLineNum = 1179658;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_INDICATE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_INDICATE)!=0) { 
RDebugUtils.currentLine=1179659;
 //BA.debugLineNum = 1179659;BA.debugLine="Output.Append(\"EXTENDED_INDICATE \")";
_output.Append("EXTENDED_INDICATE ");
 };
RDebugUtils.currentLine=1179661;
 //BA.debugLineNum = 1179661;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_NOTIFY) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_NOTIFY)!=0) { 
RDebugUtils.currentLine=1179662;
 //BA.debugLineNum = 1179662;BA.debugLine="Output.Append(\"NOTIFY \")";
_output.Append("NOTIFY ");
 };
RDebugUtils.currentLine=1179664;
 //BA.debugLineNum = 1179664;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_READ) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_READ)!=0) { 
RDebugUtils.currentLine=1179665;
 //BA.debugLineNum = 1179665;BA.debugLine="Output.Append(\"READ \")";
_output.Append("READ ");
 };
RDebugUtils.currentLine=1179667;
 //BA.debugLineNum = 1179667;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_SIGNED_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_SIGNED_WRITE)!=0) { 
RDebugUtils.currentLine=1179668;
 //BA.debugLineNum = 1179668;BA.debugLine="Output.Append(\"SIGNED_WRITE \")";
_output.Append("SIGNED_WRITE ");
 };
RDebugUtils.currentLine=1179670;
 //BA.debugLineNum = 1179670;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_WRITE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_WRITE)!=0) { 
RDebugUtils.currentLine=1179671;
 //BA.debugLineNum = 1179671;BA.debugLine="Output.Append(\"WRITE \")";
_output.Append("WRITE ");
 };
RDebugUtils.currentLine=1179673;
 //BA.debugLineNum = 1179673;BA.debugLine="If Bit.AND(cha.Properties , cha.PROPERTY_WRITE_NO_RESPONSE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getProperties(),_cha.PROPERTY_WRITE_NO_RESPONSE)!=0) { 
RDebugUtils.currentLine=1179674;
 //BA.debugLineNum = 1179674;BA.debugLine="Output.Append(\"WRITE_NO_RESPONSE \")";
_output.Append("WRITE_NO_RESPONSE ");
 };
RDebugUtils.currentLine=1179677;
 //BA.debugLineNum = 1179677;BA.debugLine="Return Output.ToString";
if (true) return _output.ToString();
RDebugUtils.currentLine=1179679;
 //BA.debugLineNum = 1179679;BA.debugLine="End Sub";
return "";
}
public static String  _blecharacteristicwritetypetostring(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _cha) throws Exception{
RDebugUtils.currentModule="main";
anywheresoftware.b4a.keywords.StringBuilderWrapper _output = null;
RDebugUtils.currentLine=1245184;
 //BA.debugLineNum = 1245184;BA.debugLine="Sub BleCharacteristicWriteTypeToString ( cha As BleCharacteristic) As String";
RDebugUtils.currentLine=1245185;
 //BA.debugLineNum = 1245185;BA.debugLine="Dim Output As StringBuilder";
_output = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
RDebugUtils.currentLine=1245187;
 //BA.debugLineNum = 1245187;BA.debugLine="Output.Initialize";
_output.Initialize();
RDebugUtils.currentLine=1245188;
 //BA.debugLineNum = 1245188;BA.debugLine="If Bit.AND(cha.WriteType , cha.WRITE_TYPE_DEFAULT) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getWriteType(),_cha.WRITE_TYPE_DEFAULT)!=0) { 
RDebugUtils.currentLine=1245189;
 //BA.debugLineNum = 1245189;BA.debugLine="Output.Append(\"TYPE_DEFAULT \")";
_output.Append("TYPE_DEFAULT ");
 };
RDebugUtils.currentLine=1245191;
 //BA.debugLineNum = 1245191;BA.debugLine="If Bit.AND(cha.WriteType , cha.WRITE_TYPE_NO_RESPONSE) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getWriteType(),_cha.WRITE_TYPE_NO_RESPONSE)!=0) { 
RDebugUtils.currentLine=1245192;
 //BA.debugLineNum = 1245192;BA.debugLine="Output.Append(\"TYPE_NO_RESPONSE \")";
_output.Append("TYPE_NO_RESPONSE ");
 };
RDebugUtils.currentLine=1245194;
 //BA.debugLineNum = 1245194;BA.debugLine="If Bit.AND(cha.WriteType , cha.WRITE_TYPE_SIGNED) <> 0 Then";
if (anywheresoftware.b4a.keywords.Common.Bit.And(_cha.getWriteType(),_cha.WRITE_TYPE_SIGNED)!=0) { 
RDebugUtils.currentLine=1245195;
 //BA.debugLineNum = 1245195;BA.debugLine="Output.Append(\"TYPE_SIGNED \")";
_output.Append("TYPE_SIGNED ");
 };
RDebugUtils.currentLine=1245198;
 //BA.debugLineNum = 1245198;BA.debugLine="Return Output.ToString";
if (true) return _output.ToString();
RDebugUtils.currentLine=1245199;
 //BA.debugLineNum = 1245199;BA.debugLine="End Sub";
return "";
}
public static String  _ble_devicefound(String _name,String _macaddress) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub ble_DeviceFound (Name As String, MacAddress As String)";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Log(Name & \", \" & MacAddress)";
anywheresoftware.b4a.keywords.Common.Log(_name+", "+_macaddress);
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Log(\"Connecting...\")";
anywheresoftware.b4a.keywords.Common.Log("Connecting...");
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="If Connect == cstateIdle Then";
if (_connect==_cstateidle) { 
RDebugUtils.currentLine=327687;
 //BA.debugLineNum = 327687;BA.debugLine="manager.Connect(MacAddress, False)";
_manager.Connect(_macaddress,anywheresoftware.b4a.keywords.Common.False);
 };
RDebugUtils.currentLine=327689;
 //BA.debugLineNum = 327689;BA.debugLine="End Sub";
return "";
}
public static String  _ble_disconnected() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub ble_Disconnected";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="Log(\"ble_Disconnected\")";
anywheresoftware.b4a.keywords.Common.Log("ble_Disconnected");
RDebugUtils.currentLine=655364;
 //BA.debugLineNum = 655364;BA.debugLine="End Sub";
return "";
}
public static String  _ble_discoveryfinished() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub ble_DiscoveryFinished";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="Log(\"ble_DiscoveryFinished\")";
anywheresoftware.b4a.keywords.Common.Log("ble_DiscoveryFinished");
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="End Sub";
return "";
}
public static String  _delay(long _nmillisecond,boolean _enableevents) throws Exception{
RDebugUtils.currentModule="main";
long _nbegintime = 0L;
long _nendtime = 0L;
RDebugUtils.currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Sub Delay(nMilliSecond As Long, EnableEvents As Boolean)";
RDebugUtils.currentLine=983041;
 //BA.debugLineNum = 983041;BA.debugLine="Dim nBeginTime As Long";
_nbegintime = 0L;
RDebugUtils.currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="Dim nEndTime As Long";
_nendtime = 0L;
RDebugUtils.currentLine=983043;
 //BA.debugLineNum = 983043;BA.debugLine="nEndTime = DateTime.Now + nMilliSecond";
_nendtime = (long) (anywheresoftware.b4a.keywords.Common.DateTime.getNow()+_nmillisecond);
RDebugUtils.currentLine=983044;
 //BA.debugLineNum = 983044;BA.debugLine="nBeginTime = DateTime.Now";
_nbegintime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
RDebugUtils.currentLine=983045;
 //BA.debugLineNum = 983045;BA.debugLine="Do While nBeginTime < nEndTime";
while (_nbegintime<_nendtime) {
RDebugUtils.currentLine=983046;
 //BA.debugLineNum = 983046;BA.debugLine="nBeginTime = DateTime.Now";
_nbegintime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
RDebugUtils.currentLine=983048;
 //BA.debugLineNum = 983048;BA.debugLine="If nEndTime < nBeginTime Then";
if (_nendtime<_nbegintime) { 
RDebugUtils.currentLine=983049;
 //BA.debugLineNum = 983049;BA.debugLine="Return";
if (true) return "";
 };
RDebugUtils.currentLine=983051;
 //BA.debugLineNum = 983051;BA.debugLine="If (EnableEvents) Then";
if ((_enableevents)) { 
RDebugUtils.currentLine=983052;
 //BA.debugLineNum = 983052;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 };
 }
;
RDebugUtils.currentLine=983055;
 //BA.debugLineNum = 983055;BA.debugLine="End Sub";
return "";
}
public static String  _button3_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub Button3_Click					'Send data";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="Log(\"Message \" & x)";
anywheresoftware.b4a.keywords.Common.Log("Message "+BA.NumberToString(_x));
RDebugUtils.currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="Log(\" write Val : \" & x)	'";
anywheresoftware.b4a.keywords.Common.Log(" write Val : "+BA.NumberToString(_x));
RDebugUtils.currentLine=917508;
 //BA.debugLineNum = 917508;BA.debugLine="cwrite.SetIntValue(  x,cwrite.FORMAT_UINT8,0 )   ' first write it to charateristc locally";
_cwrite.SetIntValue((int) (_x),_cwrite.FORMAT_UINT8,(int) (0));
RDebugUtils.currentLine=917509;
 //BA.debugLineNum = 917509;BA.debugLine="x = (x + 1) Mod 2";
_x = (byte) ((_x+1)%2);
RDebugUtils.currentLine=917510;
 //BA.debugLineNum = 917510;BA.debugLine="manager.WriteCharacteristic(cwrite)							 ' then write/sent it to the device";
_manager.WriteCharacteristic(_cwrite);
RDebugUtils.currentLine=917511;
 //BA.debugLineNum = 917511;BA.debugLine="End Sub";
return "";
}
public static String  _timer_tick() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Sub Timer_Tick";
RDebugUtils.currentLine=1048601;
 //BA.debugLineNum = 1048601;BA.debugLine="End Sub";
return "";
}
}